<template>
  <div class="layout" :class="{ min: convStarted }">
    <div class="title" :class="{ min: convStarted }">
      <div class="inner">
        <IconAi />
        <p class="title-text">
          <span class="ai-gradien">Hey</span> {{ name }}! How can I help you today ?
        </p>
      </div>
    </div>

    <div v-if="convStarted" class="dialog">
      <Conversation :dialogs="dialogs" />
    </div>
  </div>

  <footer>
      <VueVoiceRecording @getAsMp3="handleRecord"></VueVoiceRecording>
    <div class="audio-icon" @click="handleClick" v-if="!recording">
      <IconAudio />
    </div>
    <div class="audio-recording" v-else>test</div>
  </footer>
</template>

<script setup lang="ts">
    import { ref} from 'vue'
import IconAi from './components/IconAi.vue'
import IconAudio from './components/IconAudio.vue'
import Conversation from './components/Conversation.vue'
import type { DialogType } from './types'

    import {VueVoiceRecording} from 'vue-voice-recording';
    import 'vue-voice-recording/dist/style.css'

const name = ref<string>('Léa')
const convStarted = ref<boolean>(true)
const recording = ref<boolean>(false)

const dialogs = ref<DialogType[]>([])

    async function handleRecord(blob) {

        const b = new FormData()
        b.append('file', blob.data)

        const a = await fetch('http://localhost:8080/api/file', {
            body: b,
            method: 'POST'
        })

        console.log(await a.json());
    }

    async function handleClick() {
        recording.value = true;
        const str = 'I am looking for a best freelancer';
        const b = new FormData()
        b.append('prompt', str)
        dialogs.value.push({
            message: str,
            me: true
        });

        const a = await fetch('http://localhost:8080/api/prompt', {
            body: b,
            method: 'POST'
        })
        const c = await a.json();

        dialogs.value.push({
            message: c.message
        });
    }
</script>

<style scoped lang="scss">
.layout {
  height: 80vh;
  padding: 20px 0;
  display: flex;
  align-items: center;
  &.min {
    display: block;
  }
}

.dialog {
  width: 100%;
  margin-top: 20px;
  padding-right: 15px;
  height: 500px;
      overflow-y: auto;
}

.title.min {
  display: block;
  background-color: #fff;
  box-shadow: 0px 0px 16px #ccc;
  width: 100%;
  padding: 8px 20px;
  border-radius: 14px 14px 14px 0;
  .inner {
    display: flex;
    align-items: center;
    gap: 10px;
  }
  .title-text {
    font-size: 20px;
    font-weight: normal;
  }
}

footer {
  height: 20vh;
}

.title-text {
  font-size: 56px;
  font-weight: 700;
  font-family: Arial, Helvetica, sans-serif;
  line-height: 60px;
}

.ai-gradien {
  background: -webkit-linear-gradient(90deg, #9c2ca7 0%, rgba(255, 68, 79, 0.85) 100%);
  font-weight: 700;
  -webkit-background-clip: text;
  -webkit-text-fill-color: transparent;
}

.audio-icon {
  cursor: pointer;
  width: 72px;
  height: 72px;
  margin: 0 auto;
  justify-content: center;
  align-items: center;
  display: flex;
  border-radius: 100%;
  box-shadow: 0px 5px 4px #ebebeb;

  &:hover {
    box-shadow: 0px 5px 4px #ccc;
  }
}
</style>
